routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'UsersController@index')->name('home')->middleware('auth');

Route::resource('posts', 'PostsController')->middleware('auth');
Route::resource('posts.comments', 'CommentsController')->middleware('auth');
Route::resource('users', 'UsersController')->only('index')->middleware('auth');
Route::get('follow/{user}', 'UsersController@follow')->name('follow')->middleware('auth');
Route::resource('posts.likes', 'LikesController')->only('store')->middleware('auth');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/User.php
<?php

namespace App;

use Orchid\Platform\Models\User as Authenticatable;

class User extends Authenticatable
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'last_login',
        'permissions',
    ];

    /**
     * The attributes excluded from the model's JSON form.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
        'permissions',
        'uses_two_factor_auth',
        'two_factor_secret_code',
        'two_factor_recovery_code',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'permissions'          => 'array',
        'email_verified_at'    => 'datetime',
        'last_login'           => 'datetime',
        'uses_two_factor_auth' => 'boolean',
    ];

    /**
     * The attributes for which you can use filters in url.
     *
     * @var array
     */
    protected $allowedFilters = [
        'id',
        'name',
        'email',
        'permissions',
    ];

    /**
     * The attributes for which can use sort in url.
     *
     * @var array
     */
    protected $allowedSorts = [
        'id',
        'name',
        'email',
        'last_login',
        'updated_at',
        'created_at',
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function comments() {
        return $this->hasMany(Comment::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function posts() {
        return $this->hasMany(Post::class);
    }


    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsToMany
     */
    public function subscribers()
    {
        return $this->belongsToMany(
            self::class,
            'subscriptions',
            'subscription_id',
            'subscriber_id'
        )->withTimestamps();
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsToMany
     */
    public function subscriptions()
    {
        return $this->belongsToMany(
            self::class,
            'subscriptions',
            'subscriber_id',
            'subscription_id'
        )->withTimestamps();
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsToMany
     */
    public function likes() {
        return $this->belongsToMany(Post::class, 'likes');
    }
}

app/Http/Controllers/UsersController.php
<?php

namespace App\Http\Controllers;

use App\Post;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class UsersController extends Controller
{
    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index(Request $request)
    {
        $posts = Post::all();
        $user = Auth::user();
        $followed_users = $user->subscriptions()->get();
        $my_id = $request->user()->id;
        $users = User::select('id', 'name', 'email', 'password', 'email_verified_at', 'remember_token', 'created_at', 'updated_at')
            ->whereNotIn('id', [$my_id])->inRandomOrder()->take(10)->get();
        $diff = $users->diff($followed_users);
        $users = $diff->all();
        return view('users.index', compact('users', 'posts'));
    }

    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function follow(Request $request, $id)
    {
        $user = User::findOrFail($id);
        Auth::user();
        $my_id = $request->user()->id;
        $user->subscribers()->attach($my_id);
        return redirect()->route('posts.index')->with('message', "You are following {$user->name}!");
    }
}

resources/views/users/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        @if (session('message'))
            <div class="alert alert-primary" role="alert">
                {{ session('message') }}
            </div>
        @endif
        @if(Auth::user())
            <div class="row">
                <h5>Recommended for you</h5>
            </div>
            <div class="row d-flex justify-content-center">
                @foreach($users as $user)
                    <div class="card m-1" style="width: 300px">
                        <div class="media p-3">
                            <img class="d-flex rounded-circle mt-0 mr-3" style="width: 50px; height: 50px"
                                 src="{{asset('/images/default_photo.jpeg')}}" alt="Image">
                            <div class="media-body">
                                <p class="pr-4">{{$user->name}}</p>
                            </div>
                        </div>
                        <div class="card-footer">
                            <a href="{{url('follow', ['user' => $user])}}">Follow</a>
                        </div>
                    </div>
                @endforeach
            </div>
            <div class="row d-flex justify-content-center">
                <div>
                    <a href="{{route('posts.create')}}"
                       class="btn btn-info active mt-4" role="button">Create a new post</a>
                </div>
            </div>
            <div class="row d-flex justify-content-center">
                @csrf
                @foreach($posts as $post)
                    @if($post->user->id == Auth::user()->id)
                        <div class="col-md-4 mt-4" id="delete-post-{{$post->id}}">
                            <div class="card ml-0 mr-0">
                                <div class="card-header d-flex justify-content-between">
                                    {{$post->user->name}}
                                </div>
                                <div class="card-body">
                                    <img class="img-fluid"
                                         src="{{asset('/storage/' . $post->image)}}" alt="Photo">
                                    <blockquote class="blockquote mb-0 pt-1">
                                        <p class="text-truncate" style="font-size: 15px;">
                                            {{ $post->description }}
                                        </p>
                                    </blockquote>
                                    <a href="{{route('posts.show', ['post' =>$post])}}"
                                       class="card-link mb-0">Show post</a>
                                    @can('update', $post)
                                        <a href="{{route('posts.edit', ['post' => $post])}}"
                                           class="card-link">Edit post</a>
                                    @endcan
                                    <div class="d-flex justify-content-between pb-0">
                                        @if($post->likes->count() > 0)
                                            <a><i class="fa fa-heart" style="color: indianred"
                                                  aria-hidden="true"></i>
                                                <span style="font-size: 12px"> {{$post->likes->count()}} </span></a>
                                        @endif
                                    </div>
                                </div>
                                <div class="card-footer">
                                    <div class="d-flex justify-content-between">
                                        @if ($post->comments->count() == 1)
                                            <span> {{$post->comments->count()}} Comment</span>
                                        @elseif($post->comments->count() > 1 || $post->comments->count() == 0)
                                            <span> {{$post->comments->count()}} Comments</span>
                                        @endif
                                        @can('delete', $post)
                                            <input type="hidden" id="post-id" value="{{$post->id}}">
                                            <span data-post-id="{{$post->id}}" class="delete"
                                                  aria-hidden="true">&times;</span>
                                        @endcan
                                    </div>
                                </div>
                            </div>
                        </div>
                    @endif
                @endforeach
            </div>
    </div>
    @endif
@endsection